unit GlassUnit;
{ *************************************************
  *            FormRgn library 02.08.99           *
  *           written by Grigoriev Anton          *
  *                                               *
  *                  Demo program                 *
  ************************************************* }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FormRgn, StdCtrls;

type
  TForm1 = class(TForm)
    CBoxBS: TComboBox;
    Label1: TLabel;
    CBoxTS: TComboBox;
    Label2: TLabel;
    CBoxTransp: TComboBox;
    CBoxAltTransp: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    CBoxShape: TComboBox;
    Label5: TLabel;
    GlassRegion: TGlassRegion;
    Button1: TButton;
    ColorDialog: TColorDialog;
    Button2: TButton;
    TextExtRgn1: TTextExtRgn;
    procedure FormCreate(Sender: TObject);
    procedure CBoxBSChange(Sender: TObject);
    procedure CBoxTSChange(Sender: TObject);
    procedure CBoxTranspChange(Sender: TObject);
    procedure CBoxAltTranspChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure GlassRegionGetGlassColor(Sender: TObject; X, Y: Integer;
      Rect: TRect; var Red, Green, Blue: Byte);
    procedure GlassRegionGetTransparency(Sender: TObject; X, Y: Integer;
      Rect: TRect; var Transparency: TTransparency);
    procedure Button2Click(Sender: TObject);
    procedure CBoxShapeChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
 begin
  CBoxBS.ItemIndex:=0;
  CBoxTS.ItemIndex:=0;
  CBoxTransp.ItemIndex:=5;
  CBoxAltTransp.ItemIndex:=10;
  CBoxShape.ItemIndex:=0
 end;

procedure TForm1.CBoxBSChange(Sender: TObject);
 begin
  GlassRegion.BackStyle:=TBackgroundStyle(CBoxBS.ItemIndex)
 end;

procedure TForm1.CBoxTSChange(Sender: TObject);
 begin
  GlassRegion.TranspStyle:=TTransparencyStyle(CBoxTS.ItemIndex)
 end;

procedure TForm1.CBoxTranspChange(Sender: TObject);
 begin
  GlassRegion.Transparency:=10*CBoxTransp.ItemIndex
 end;

procedure TForm1.CBoxAltTranspChange(Sender: TObject);
 begin
  GlassRegion.AltTransparency:=10*CBoxAltTransp.ItemIndex
 end;

procedure TForm1.Button1Click(Sender: TObject);
 begin
  if ColorDialog.Execute then
   GlassRegion.Color:=ColorDialog.Color 
 end;

procedure TForm1.GlassRegionGetGlassColor(Sender:TObject;X,Y:Integer;Rect:TRect;var Red,Green,Blue:Byte);
 begin
  Red:=Round(255*X/(Rect.Right-Rect.Left-1));
  Green:=0;
  Blue:=Round(255*Y/(Rect.Bottom-Rect.Top-1))
 end;

procedure TForm1.GlassRegionGetTransparency(Sender:TObject;X,Y:Integer;Rect:TRect;var Transparency:TTransparency);
 begin
  Transparency:=Round((GlassRegion.AltTransparency-GlassRegion.Transparency)*Sqr(Sin(Pi*X/(Rect.Right-Rect.Left-1)))*Sqr(Sin(Pi*Y/(Rect.Bottom-Rect.Top-1)))+GlassRegion.Transparency)
 end;

procedure TForm1.Button2Click(Sender: TObject);
 begin
  ShowMessage('Demo program from FormRgn Delphi library, written by Grigoriev Anton'#13#10'      If it is interesting for you, e-mail me at grigorievab@mail.ru')
 end;

procedure TForm1.CBoxShapeChange(Sender: TObject);
 begin
  case CBoxShape.ItemIndex of
   0:GlassRegion.Region:='RX+140,C+10,R-10,B-10';
   1:GlassRegion.Region:='EX+140,C+10,R-10,B-10';
   2:GlassRegion.Region:='TCC(X+R+130)/2,(C+B)/2,TextExtRgn1';
   3:GlassRegion.Region:='L(X+R)/2+65,(C+B)/2-150,(X+R)/2+153,(C+B)/2+121,(X+R)/2-78,(C+B)/2-46,(X+R)/2+208,(C+B)/2-46,(X+R)/2-23,(C+B)/2+121';
   4:GlassRegion.Region:='W(X+R)/2+65,(C+B)/2-150,(X+R)/2+153,(C+B)/2+121,(X+R)/2-78,(C+B)/2-46,(X+R)/2+208,(C+B)/2-46,(X+R)/2-23,(C+B)/2+121'
  end
 end;

end.
